How to solve K?

# | User | Rating |
---|---|---|

1 | tourist | 3556 |

2 | wxhtxdy | 3520 |

3 | Radewoosh | 3409 |

4 | Benq | 3368 |

5 | mnbvmar | 3280 |

6 | ecnerwala | 3278 |

7 | LHiC | 3276 |

8 | sunset | 3264 |

9 | maroonrk | 3159 |

10 | TLE | 3145 |

# | User | Contrib. |
---|---|---|

1 | Errichto | 189 |

2 | Radewoosh | 177 |

3 | tourist | 173 |

4 | antontrygubO_o | 172 |

5 | PikMike | 166 |

5 | Vovuh | 166 |

7 | rng_58 | 158 |

8 | majk | 156 |

9 | farmersrice | 154 |

10 | Um_nik | 153 |

How to solve K?

How to solve E,K?

I didn't help but notice that almost each contest there's at least some solutions that are clearly incorrect but get accepted nevertheless. For example, discussions for last 3 numbered CF rounds:

- https://codeforces.com/blog/entry/62750?#comment-467811
- https://codeforces.com/blog/entry/62692
- https://codeforces.com/blog/entry/62594?#comment-465649

Sometimes problemsetters/testers could have done better job, sometimes it's seems close to impossible to fail specific solutions in advance without actually coming up with this solution.

So, here is an idea which I both thought of myself and also heard from several other people: What if after the contest and system testing phase there was open hacking phase, which doesn't give any points for hackers but helps to find solutions that should not be accepted.

It seems that it should be easily implementable, considering it already works somewhat like this in Educational rounds, but MikeMirzayanov may comment on that.

I see, however, several possible issues with that:

- It will require to wait for round results longer.
- It will not work very well for onsite competitions when results should be declared shortly after the contest (But in these cases open hacking phase could be cancelled or shortened(there's normally much less solutions to check after all))
- Author may get more lazy with creating tests (i.e saying "ok, contestants will hack that anyway"), which may reduce overall quality of the resulting testsets
- There will be people who are more targeted by hacks then others, which may be viewed as not fair. E.g if you are tourist , your bug in problem A will probably be found because your code is reviewed by a lot of participants who know about you personally (or see you in the first line of scoreboard), but a lot less people will read few thousands of (preliminarily) accepted solutions.
- For solutions that involve random number generators and/or are close to TL balance may be somewhat changed. E.g if I know, that mnbvmar's solution worked in 998ms out of 1s, I'll probably try to "hack" using (almost) same tests few times. Again, I will care less about people who are lower in the scoreboard because hacking them will not get me closer to the hoodie.

However, I think positive impact of this feature would be less important then negative impact.

What do you think? Any other issues you can think of or any other comments are welcome.

It seems something went wrong with updates to polygon certificate and it's now expired

Expired: Saturday, 22 July 2017 at 05:55:00 Moscow

The next round is at 14:00 UTC today

Top20 advances to the on-site round in Dublin

Round starts at 14:00 UTC today and 25 participants will advance to final round in Dublin.

Starts in less than 3 hours

Top 200 from round 2 are allowed to participate and top 25 (aged 18+) will advance to onsite finals

Let's discuss problems here.

Tomorrow is GP of Dolgoprudny which is prepared by my colleagues and me.

Hope, you'll like the problems which we can discuss here after the contest.

Also, we've prepared mini-tutorial which I'll post here after the contest too.

Good luck!

Tomorrow, 16:00 UTC (well, at least if calculated correctly)

UPD: you have 10 more minutes to register

Today, at 6 PM MSK (3 PM UTC)

Width of free space is decreasing by *v*_{1} + *v*_{2} per second. It means that it'll decrease from *L* to *d* in seconds. The moment when width gets a value of *d* is the last when Luke is alive so *t* is the answer.

Sort array in descending order.

Iterate over all letters, First letter is added *c*_{1} = *a*_{1} times, each other letter is added *c*_{i} = *min*(*a*_{i}, *c*_{i - 1}). Don't forget that if some letter is not added at all, then all next letters are not added too.

623A - Graph and String Note that all vertices "b" are connected with all other vertices in the graph. Find all such vertices and mark them as "b". Now we need to find any unlabeled vertex *V*, mark it with "a" character. Unlabeled vertices connected with *V* should be also labeled as "a". All other vertices we can label as "c"

Finally we need to check graph validity. Check that all vertices "a" are only connected with each other and "b" vertices. After that we need to perform a similar check for "c" vertices.

At least one of ends (*a*_{1} or *a*_{n}) is changed by at most 1. It means that if gcd > 1 then it divides on of prime divisors of either *a*_{1} - 1, *a*_{1}, *a*_{1} + 1, *a*_{n} - 1, *a*_{n} or *a*_{n} + 1. We will iterate over these primes.

Suppose prime *p* is fixed. For each number we know that it's either divisible by *p* or we can pay *b* to fix it or it should be in the subarray to change for *a*

We can use dynamic programming dp[number of numbers considered][subarray to change not started/started/finished] = minimal cost

Complexity is *O*(*Nd*) = *O*(*Nlog*(*max*(*a*_{i})), where *d* is the number of primes to check.

First of all consider cases where all points are projected to the same axis. (In that case answer is difference between maximum and minimum of this coordinate).

Now consider leftmost and rightmost points among projected to *x* axis. Let *x*_{L} and *x*_{R} are their *x*-coordinates. Notice that points with x-coordinate *x*_{L} ≤ *x* ≤ *x*_{R} may also be projected to *x*-axis and that will not increase the diameter. So, if we sort all points by *x*-coordinate, we may suppose that points projected to *x*-axis form a continuous subarray.

We will use a binary search. Now we will need to check if it's possible to project point in a such way that diameter is <= M.

Let's fix the most distant by *x*-coordinate point from 0 that is projected to *x*-axis. It may be to the left or to the right of 0. This cases are symmetrical and we will consider only the former one. Let *x*_{L} < 0 be its coordinate. Notice that one may project all points such that 0 ≤ *x* - *x*_{L} ≤ *M* and |*x*| ≤ |*x*_{L}| to the *x* axis (and it'll not affect the diameter) and we have to project other points to *y*-axis. Among all other points we should find the maximum and minimum by *y* coordinate. Answer is "yes (*diam* ≤ *M*)" if *y*_{max} - *y*_{min} < = *M* and distance from (*x*_{L}, 0) to both (0, *y*_{max}) and (0, *y*_{min}) is not greater than M.

Let's precalculate maximums and minimums of *y* coordinates on each prefix and suffix of original (sorted) points array. Now iterate over left border of subarray of points projected to *x*-axis and find the right border using binary search or maintain it using two-pointers technique.

So we've got one check in *O*(*M*) or and entire solution in or

Let's denote *q*_{i} = 1 - *p*_{i}.

Main idea: first of all guess each friend once, then maximize probability to end game on current step. Let's simulate first 300000 steps, and calculate . , where *k*_{i} — how many times we called *i*-th friend ().

Expectation with some precision equals . So it is enough to prove that:

1) Greedy strategy gives maximum values for all *Pr*(*t*).

2) On 300000 step precision error will be less than 10^{ - 6}.

Proof:

1) Suppose, that for some *t* there exists set *l*_{i} (), not equal to set produced by greedy algorithm *k*_{i}, gives the maximum value of *Pr*(*t*). Let's take some *k*_{a} < *l*_{a} and *k*_{b} > *l*_{b}, it is easy to prove tgat if we change *l*_{b} to *l*_{b} + 1, *l*_{a} to *l*_{a} - 1, then new set of *l*_{i} gives bigger value of *Pr*(*t*), contradiction.

2) *q*_{i} ≤ 0.99. Let's take set , it gives probability of end of the game not less than optimal. Then *Pr*(*t*) ≥ (1 - 0.99^{t / 100})^{100} ≥ 1 - 100·0.99^{t / 100}. Precision error does not exceed . It could be estimated as sum of geometric progression. If *N* ≥ 300000 precision error doesn't exceed 10^{ - 7}.

First observation is that if the sequence of prefix xors is strictly increasing, than on each step *a*_{i} has at least one new bit comparing to the previous elements. So, since there are overall *k* bits, the length of the sequence can't be more than *k*. So, if *n* > *k*, the answer is 0.

Let's firstly solve the task with *O*(*k*^{3}) complexity. We calculate *dp*[*n*][*k*] — the number of sequences of length *n* such that *a*_{1}|*a*_{2}|... |*a*_{n} has *k* bits. The transition is to add a number with *l* new bits, and choose those *k* bits which are already in the prefix xor arbitrarily. So, *dp*[*n* + 1][*k* + *l*] is increased by *dp*[*n*][*k*]·2^{k}·*C*_{k + l}^{l}. The last binomial coefficient complies with the choice these very *l* bits from *k* + *l* which will be present in *a*_{1}|*a*_{2}|... |*a*_{n + 1}.

Note now that the transition doesn't depend on *n*, so let's try to use the idea of the binary exponentiation. Suppose we want to merge two dynamics *dp*_{1}[*k*], *dp*_{2}[*k*], where *k* is the number of bits present in *a*_{1}|*a*_{2}|... |*a*_{left} and *b*_{1}|... |*b*_{right} correspondingly. Now we want to obtain *dp*[*k*] for arrays of size *left* + *right*. The formula is:

Here *l* corresponds to the bits present in the xor of the left part, and for each number of the right part we can choose these *l* bits arbitrarily. Rewrite the formula in the following way:

So, we can compute *dp*[*k*] for all *k* having multiplied two polynomials and . We can obtain the coefficients of the first polynomial from the coefficients of the second in . So, we can compute this dynamic programming for all lengths — powers of two, in , using the fast Fourier transform. In fact, it is more convenient to compute using the same equation. After that, we can use the same merge strategy to compute the answer for the given *n*, using dynamics for the powers of two. Overall complexity is .

We decided to ask the answer modulo 10^{9} + 7 to not let the participants easily guess that these problem requires FFT :) So, in order to get accepted you had to implement one of the methods to deal with the large modulo in polynomial multiplication using FFT. Another approach was to apply Karatsuba algorithm, our realisation timed out on our tests, but TooDifficuIt somehow made it pass :)

Tutorial of AIM Tech Round (Div. 1)

Tutorial of AIM Tech Round (Div. 1)

Tutorial of AIM Tech Round (Div. 2)

Tutorial of AIM Tech Round (Div. 2)

Round 1 starts in 10 hours

Note, that rules were changed:

To advance to Round 2 you need to score 30 points or more.

You need to get 20 points in order to advance to Round 1.

Registration is started!

Schedule:

- Qualification April 10 23:00 UTC

Discussion - Round 1A April 18 01:00 UTC (anyone who get fixed number of points in qual).

Discussion. - Round 1B May 2 16:00 UTC (anyone who was allowed to participate in 1A, but didn't advance to round 2 yet)

Discussion - Round 1C May 10 09:00 (anyone who was allowed to participate in 1A, but didn't advance to round 2 yet)
- Round 2 May 30 14:00 UTC (Top 1000 from each 1X round)

Discussion - Round 3 June 13 14:00 UTC (Top 500 from Round 2)

T-shirts are for top 1000 in Round 2.

Distributed Code Jam is also introduced

Contest is over.

How to solve D ?

How to solve F correctly?

In this problem one needed to implement what was written in the statement: create matrix (two-dimensional array) using given rules and find maximal value in the table.

It is also possible to see that maximal element is always in bottom-right corner.

Easier solution with recursion also was enough to get AC:

```
def elem(row, col):
if row == 1 or col == 1:
return 1
return elem(row - 1, col) + elem(row, col - 1)
```

One may see the Pascal's triangle in the given matrix and understand that answer is equal to

Prepared by: AlexDmitriev

Author of editorial: AlexDmitriev

Suppose there are two piles with number of pebbles differed by more than *k*, then there is no solution:

Now let *M* = *max* *a*_{i} ≤ *min* *a*_{i} + *k* = *m* + *k*.

There's a way to construct correct coloring:

- Chose
*m*peebles from each pile and assign first color to them. - In each pile assign different colors to all other pebbles (you may use first color once more) (It's possible bacause there are no more than
*k*uncolored pebbles.

Now there are *m* or *m* + 1 pebbles of first color and 0 or 1 pebbles of any other color in each pile.

Prepared by: Kostroma

Author of editorial: AlexDmitriev

The algorithm is greedy: first, take the minimal number with sum of digits *a*_{1} — call it *b*_{1}. Then, on the *i*-th step take *b*_{i} as the minimal number with sum of digits *a*_{i}, which is more than *b*_{i - 1}.

It can be easily proven that this algorithm gives an optimal answer. But how to solve the subproblem: given *x* and *y*, find the minimal number with sum of digits *x*, which is more than *y*?

We use a standard approach: iterate through the digits of *y* from right to left, trying to increase the current digit and somehow change the digits to the right in order to reach the sum of digits equal to *x*. Note that if we are considering the (*k* + 1)-th digit from the right and increase it, we can make the sum of *k* least significant digits to be any number between 0 and 9*k*. When we find such position, that increasing a digit in it and changing the least significant digits gives us a number with sum of digits *x*, we stop the process and obtain the answer. Note that if *k* least significant digits should have sum *m* (where 0 ≤ *m* ≤ 9*k*), we should obtain the answer greedily, going from the right to the left and putting to the position the largest digit we can.

Let us bound the maximal length of the answer, i.e. of *b*_{n}. If some *b*_{i} has at least 40 digits, than we take the minimal *k* such that 10^{k} ≥ *b*_{i}. Than between 10^{k} and 10^{k + 1} there exist numbers with any sum of digits between 1 and 9*k*. If *k* ≥ 40, than 9*k* ≥ 300, which is the upper bound of all *b*_{i}. So, in the constraints of the problem, *b*_{i + 1} will be less than 10^{k + 1}. Than, similarly, *b*_{i + 2} < 10^{k + 2} and so on. So, the length of the answer increases by no more than one after reaching the length of 40. Consequently, the maximal length of the answer can't be more than 340.

The complexity of solution is *O*(*n*·*maxLen*). Since *n* ≤ 300, *maxLen* ≤ 340, the solution runs much faster the time limit.

Prepared by: Endagorion

Author of editorial: Kostroma

First we note that if the sequences *a*_{i} and *b*_{i} are a valid solution, then so are the sequences *a*_{i} - *P* and *b*_{i} + *P* for any integer *P*. This means that we can consider *a*_{1} to be equal to 0 which allows us to recover the sequence *b*_{i} by simply taking the first row of the matrix. Knowing *b*_{i} we can also recover *a*_{i} (for example by subtracting *b*_{1} from the first column of the matrix) At this stage we allow *a*_{i} and *b*_{i} to contain negative numbers, which can be later fixed by adding *K* a sufficient amount of times. Now we consider the “error” matrix *e*: .

If *e* consists entirely of 0s, then we’ve found our solution by taking a sufficiently large *K*. That is: *K* > *max*_{i, j}(*w*_{i, j}).

Otherwise, we note that *e*_{i, j} = 0(*modK*) which implies that *K* is a divisor of *g* = *gcd*_{i, j}(*e*_{i, j}). The greatest such number is *g* itself, so all that remains is to check if *g* is strictly greater than all the elements of the matrix *w*. If that is the case, then we’ve found our solution by setting *K* = *g*. Otherwise, there’s no solution.

Prepared by: Kostroma, AlexDmitriev

Author of editorial: AlexDmitriev

We first calculate the prefix sums of *vowel*(*s*_{i}) which allows to calculate the sum of *vowel*(*s*_{i}) on any substring in *O*(1) time.

For all *m* from 1 to , we will calculate the sum of simple pretinesses of all substrings of that length, let’s call it *SP*_{m}. For that purpose, let’s calculate the number of times the *i*-th character of the string *s* is included in this sum.

For *m* = 1 and *m* = |*s*|, every character is included exactly 1 time. For *m* = 2 and *m* = |*s*| - 1, the first and the last character are included 1 time and all other characters are included 2 times. For *m* = 3 and *m* = |*s*| - 2 the first and the last character are included 1 time, the second and the pre-last character are included 2 times and all others are included 3 times, and so on.

In general, the *i*-th character is included *min*(*m*, |*s*| - *m* + 1, *i*, |*s*| — *i* + 1) times. Note that when moving from substrings of length *m* to substrings of length *m* + 1, there are 2 ways in which the sum *SP* can change:

- If
*m*> |*s*| -*m*+ 1, then*SP*is decreased by the number of vowel occurrences in the substring from |*s*| -*m*+ 1 to*m*. - Otherwise,
*SP*is increased by the number of vowel occurrences in the substring from*m*to |*s*| -*m*+ 1.

This way we can easily recalculate *SP*_{m + 1} using *SP*_{m} by adding (subtracting) the number of vowel occurrences on a substring (which is done in *O*(1) time). The complexity of this solution is *O*(*N*).

Prepared by: zemen

Author of editorial: zemen

Consider a tree with *n* vertices rooted at vertex 1 and let *b* be the pseudocode’s (DFS) resulting sequence. Then *b*[*l*_{v}..*l*_{v} + *size*_{v} - 1], represents vertex *v*’s subtree, where *l*_{v} is the index of *v* in *b* and *size*_{v} is the size of $v$’s subtree.

Let’s solve the problem using this fact and Dynamic Programming. Let *e*[*l*, *r*] be the number of trees consisting of vertices *a*[*l*], *a*[*l* + 1], …, *a*[*r*] such that running DFS starting from *a*[*l*] will result in a sequence with vertices in the same order as their order in *a*.

The base case is when *l* = *r* and *e*[*l*, *r*] = 1. Otherwise, where the sum is taken over all partitions of the segment [*l* + 1, *r*], that is, over all *k*;*pos*_{1}, ..., *pos*_{k + 1}, such that *l* + 1 = *pos*_{1} < *pos*_{2} < ... < *pos*_{k + 1} = *r*, 1 ≤ *k* ≤ *r* - *l*, *a*[*pos*_{1}] < *a*[*pos*_{2}] < ... < *a*[*pos*_{k}]. Each such partition represents a different way to distribute the vertices among *a*[*l*]’s children’s subtrees. A solution using this formula for calculating *e*[*l*, *r*] will have an exponential running time.

The final idea is to introduce *d*[*l*, *r*]: = *e*[*l* - 1, *r*], 2 ≤ *l* ≤ *r* ≤ *n*. It follows that: *d*[*l*, *r*] = ([statement] is equal to 1 if the statement is true, 0 otherwise) and *e*[*l*, *r*] = *d*[*l* + 1, *r*]. This way *d*[*l*, *r*] and *e*[*l*, *r*] can be calculated in linear time for any segment [*l*, *r*]. The answer to the problem is *e*[1, *n*]. Overall complexity is *O*(*n*^{3}).

Prepared by: DPR-pavlin

Author of editorial: DPR-pavlin

Tutorial of Codeforces Round #289 (Div. 2, ACM ICPC Rules)

Tutorial of Codeforces Round #289 (Div. 2, ACM ICPC Rules)

Today at 19:00 MSK

We can discuss problems here after the contest

Hi, Codeforces.

- 0.16.2
- Support CLion 2019.1

- 0.16
- Auto switching to a file when changing task
- Auto selecting task when changing a file

- 0.15
- Fixed running in newer CLion versions
- Move debug/release changer to the combobox with run configurations.

- 0.14
- Update Chelper dependency to support Competitive companion extension.

JHelper is plugin for writing contests in C++. You may inline code from your own prewritten library so that you can submit only used code. Besides, it allows to test on tests you've added. it's planned that you'll be able to parse a problem/contest and have all samples tests automatically added.

It's available for CLion

Plugin is completely free. IDE price is 89$/year, but it's free for students, have 30-days free trial and often you can use EAP(smth like beta)-versions for free.

You may download the plugin using JetBrains plugin repository or manually from their site

Some explanations how to use that on wiki. Fell free to ask what is unclear.

Please post bugs and feature requests here or in bug tracker.

Your contributions are also welcome. Possible ways to contribute:

- Post bugs or feature requests
- Make wiki more understandable
- Implement something and create pull request.

It's still possible to make it multilingual (I mean add another **programming** languages). I am open to discuss that.

Thanks Egor for idea with his Chelper and abra for some code review.

Round 1 will last 24 hours and start December 7, 2013 at 10:00 AM PT.

The top 500 people will advance to the Round 2. In addition, anyone that scores the same number of points as the person in 500th place will also advance to Round 2

The Qualification Round starts on November 21, 2013 at 4:00 PM PT and will last 72 hours.

**What are the prizes?**

- 1st Place: $10,000 USD
- 2nd Place: $2,000 USD
- 3rd Place: $1,000 USD
- 4th-25th Place: $100 USD

**Who gets T-shirts?**

The top 100 finishers from Round 2 will get t-shirts.

Codeforces (c) Copyright 2010-2019 Mike Mirzayanov

The only programming contests Web 2.0 platform

Server time: Dec/10/2019 06:36:39 (f2).

Desktop version, switch to mobile version.

Supported by

User lists

Name |
---|